// test.c
/*
 * PM - 2017
 * lab0.c
 */
#define F_CPU 16000000

#include <avr/io.h>
#include <util/delay.h>
#include <stdlib.h>
#include <stdio.h>
#include "servo.h"
#include "stepper.h"
#include "usart.h"


void init_blink() {

	DDRD |= (1 << PD7);
}

int main(void) {

/*
	Stepper 1 : 
		PA0 - IN1
		PA1 - IN2
		PA2 - IN3
		PA3 - IN4

	Stepper 2 :
		PA4 - IN1
		PA5 - IN2
		PA6 - IN3
		PA7 - IN4

	Servomotor:
		PD5
*/

	/* 
		Perioade de delay diferite pentru ca am de translatat
	 	obiecte de greutati diferite pe axe 
	 	- sunt determinate empiric
	*/
	int periodX = 2;
	int periodY = 3;
	char command;
	char buffer[100];

	/* Initializeaza servomotor */
	init_pen();

	/* Initializeaza motoare pas cu pas */
	init_stepper1();
	init_stepper2();

	/* Seteaza LED pentru verificare */
	init_blink();

	/* Initializeaza interfata seriala */
	USART0_init();
	
	raise_pen();

	while(1) {
		/* Asteapta comanda de la tastatura */
		command = USART0_receive();
		switch(command) {
			case 'x': {
				/* translateaza cadrul pe axa Ox */
				sprintf(buffer, "Introduceti valoarea de pe axa Ox: [0 < value < 10]\n\r");
				USART0_print(buffer);
				const char c = USART0_receive();
				int pos = atoi(&c);
				USART0_print("Introduceti sensul pe axa:\n\r[p sau m]\n\r");
				const char s = USART0_receive();
				pos *= 100;
				/* Stabileste directia de translatare */
				if (s == 'p')
					rotateClockwise(&PORTA, PA0, PA1, PA2, PA3, periodX, pos);
				else
					rotateAntiClockwise(&PORTA, PA0, PA1, PA2, PA3, periodX, pos);
				break;
			}
			case 'y': {
				/* translateaza cadrul pe axa Oy */
				USART0_print("Introduceti valoarea de pe axa Oy:\n\r[0 < value < 10]\n\r");
				const char c = USART0_receive();
				int pos = atoi(&c);
				USART0_print("Introduceti sensul pe axa:\n\r[p sau m]\n\r");
				const char s = USART0_receive();
				pos *= 100;
				/* Stabileste directia de translatare */
				if (s == 'p')
					rotateClockwise(&PORTA, PA4, PA5, PA6, PA7, periodY, pos);
				else
					rotateAntiClockwise(&PORTA, PA4, PA5, PA6, PA7, periodY, pos);
				break;
			}
			case 'u': {
				/* ridica instrumentul de scris */
				USART0_print("Raising the pen\n\r");
				raise_pen();
				break;
			}
			case 'd': {
				/* coboara instrumentul de scris */
				USART0_print("Lowering the pen\n\r");
				lower_pen();
				break;
			}
			default:
				break;
		}
		/* LED de test */
		PORTD ^= (1 << PD7);
		_delay_ms(10);


	}

	return 0;
}

