#define F_CPU 16000000
#include "stepper.h"
#include <avr/io.h>
#include <util/delay.h>
#include <stdlib.h>
#include <stdio.h>

/* Functie de delay */
void my_delay(int period) {
	while (period > 0) {
		_delay_ms(1);
		period--;
	}
}
/* Initializeaza pinii de output ai primului stepper */
void init_stepper1() {

	DDRA |= (1 << PA0);
	DDRA |= (1 << PA1);
	DDRA |= (1 << PA2);
	DDRA |= (1 << PA3);
}
/* Initializeaza pinii de output ai celui de-al doilea stepper */
void init_stepper2() {

	DDRA |= (1 << PA4);
	DDRA |= (1 << PA5);
	DDRA |= (1 << PA6);
	DDRA |= (1 << PA7);
}

/* Roteste axul motorului stepper in sensul acelor de ceasornic */
void rotateClockwise(volatile uint8_t *port, int pin0, int pin1, int pin2, int pin3, int period, int steps) {

	for(int i = 0; i < steps; i++) {
		(*port) = 0;
		(*port) |= (1 << pin0);
		my_delay(period);

		(*port) = 0;
		(*port) |= (1 << pin1);
		my_delay(period);

		(*port) = 0;
		(*port) |= (1 << pin2);
		my_delay(period);

		(*port) = 0;
		(*port) |= (1 << pin3);
		my_delay(period);
	}
}
/* Roteste axul motorului in sensul invers acelor de ceasornic */
void rotateAntiClockwise(volatile uint8_t *port, int pin0, int pin1, int pin2, int pin3, int period, int steps) {

	for(int i = 0; i < steps; i++) {
		(*port) = 0;
		(*port) |= (1 << pin3);
		my_delay(period);

		(*port) = 0;
		(*port) |= (1 << pin2);
		my_delay(period);

		(*port) = 0;
		(*port) |= (1 << pin1);
		my_delay(period);

		(*port) = 0;
		(*port) |= (1 << pin0);
		my_delay(period);
	}
}